using System;
using System.Data.SqlClient;

/// <summary>
/// A class that represents a grouping of cmdlet parameters
/// </summary>
public class PsSpecCmdletParameterGroupEntry : IPsSpecDataReader
{
    public PsSpecCmdletParameterGroupEntry() { }

    public void Initialize(SqlDataReader reader, System.Collections.Generic.Dictionary<string, Int32> columnMappings)
    {
        this.count = reader.GetInt32(columnMappings["Count"]);
        this.parameterName = reader[columnMappings["ParameterName"]] as string;
        this.type = reader[columnMappings["Type"]] as string;
        this.description = reader[columnMappings["Description"]] as string;
    }

    public int Count
    {
        get { return count; }
        set { count = value; }
    }
    private int count = 0;

    public string ParameterName
    {
        get { return parameterName; }
        set { parameterName = value; }
    }
    private string parameterName = null;

    public string Type
    {
        get { return type; }
        set { type = value; }
    }
    private string type = null;

    public string Description
    {
        get { return description; }
        set { description = value; }
    }
    private string description = null;
}
