using System;
using System.Collections.Generic;
using System.Text;
using System.Xml;

namespace Microsoft.PowerShell.CmdletManagement.CompareCmdlet
{
    public class ParameterSetMismatch : Mismatch
    {
        private NonameParameterSet _parameterSet;

        public ParameterSetMismatch(NonameParameterSet parameterSet, string mismatchMessage)
            : base(mismatchMessage)
        {
            _parameterSet = parameterSet;
        }

        public override string Cmdlet {
            get {return _parameterSet.CmdletInfo.CompositeName();}
        }

        public override string ParameterSet {
            get {return _parameterSet.Name;}
        }
    }
}
