using System;
using System.Collections.Generic;
using System.Text;

using System.Management.Automation;

namespace Microsoft.PowerShell.CmdletManagement
{
    [Cmdlet(VerbsCommon.Get, "PsSpecCmdletParameterGroupEntry")]
    public class GetPsSpecCmdletParameterGroupEntryCommand : Cmdlet
    {
        [Parameter(Mandatory = false, Position = 0, ValueFromPipelineByPropertyName = true)]
        [ValidateLength(1, 50)]
        public String ProjectName
        {
            get
            {
                return _projectName;
            }
            set
            {
                _projectName = value;
            }
        }
        private string _projectName = "*";

        [Parameter(Mandatory = false)]
        public String ServiceUri
        {
            get
            {
                return _serviceUri;
            }
            set
            {
                _serviceUri = value;
            }
        }
        private string _serviceUri = PsSpecCmdletUtils.Constants.ServiceUri;


        protected override void ProcessRecord()
        {
            PsSpecCmdletService.PsSpecCmdletParameterGroupEntry[] parameters = null;

            PsSpecCmdletService.CmdletService service =
                new PsSpecCmdletService.CmdletService();
            service.Url = ServiceUri;

            service.UseDefaultCredentials = true;

            parameters = service.GetTopParameters(PsSpecCmdletUtils.ConvertWildcardToSqlWildcard(ProjectName));

            foreach (PsSpecCmdletService.PsSpecCmdletParameterGroupEntry parameter in parameters)
            {
                WriteObject(new PsSpecCmdletParameterGroupEntry(
                    parameter.Count, parameter.ParameterName, parameter.Type, parameter.Description));
            }
        }
    }
}
