using System;
using System.Collections.Generic;
using System.Text;

using System.Management.Automation;

namespace Microsoft.PowerShell.CmdletManagement
{
    [Cmdlet(VerbsCommon.Get, "PsSpecVerb")]
    public class GetPsSpecVerbCommand : Cmdlet
    {
        [Parameter(Mandatory = false, Position = 0, ValueFromPipelineByPropertyName = true)]
        [ValidateLength(1, 50)]
        public String Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
            }
        }
        private string _name = "*";

        [Parameter(Mandatory = false)]
        public String ServiceUri
        {
            get
            {
                return _serviceUri;
            }
            set
            {
                _serviceUri = value;
            }
        }
        private string _serviceUri = PsSpecCmdletUtils.Constants.ServiceUri;


        protected override void ProcessRecord()
        {
            PsSpecCmdletService.PsSpecVerb[] verbs = null;

            PsSpecCmdletService.CmdletService service =
                new PsSpecCmdletService.CmdletService();
            service.Url = ServiceUri;

            service.UseDefaultCredentials = true;

            verbs = service.GetVerb(
                PsSpecCmdletUtils.ConvertWildcardToSqlWildcard(Name));

            foreach (PsSpecCmdletService.PsSpecVerb verb in verbs)
            {
                WriteObject(new PsSpecVerb(
                    verb.Type, 
                    verb.Name, 
                    verb.Definition, 
                    verb.Comments, 
                    verb.Obsoletes, 
                    verb.Pair));
            }
        }
    }
}
