using System;
using System.ComponentModel;
using System.Management.Automation;

namespace Microsoft.PowerShell.CmdletManagement
{
    [RunInstaller(true)]
    public class CustomSnapin : PSSnapIn
    {
        public CustomSnapin() : base()
        {
        }

        ///<summary>The snapin name which is used for registration</summary>
        public override string Name
        {
            get
            {
                return "PsSpecCmdletManagement";
            }
        }

        /// <summary>Gets vendor of the snapin.</summary>
        public override string Vendor
        {
            get
            {
                return "Microsoft Corporation (Internal Use Only)";
            }
        }

        /// <summary>Gets description of the snapin. </summary>
        public override string Description
        {
            get
            {
                return "This snapin provides cmdlets to help manage PowerShell projects and cmdlets";
            }
        }
    }
}
