param($server, $database)

$nonStandardVerbs = Import-Csv ConvertedVerbs.csv | ? { $_.Comments -eq 'Do not use' }
$projectName = "PowerShell"

foreach($verb in $nonStandardVerbs)
{
    .\Add-VerbException -Server $server -Database $database `
        -Type $verb.VerbType -Name $verb.Verb -Definition $verb.Definition `
        -Comments $verb.Comments -Obsoletes $verb.Obsoletes -Pair $verb.Pair `
        -ProjectName $projectName
}